//*****************************************************************************
//* FILE NAME:       DebugPrint.h
//* FILE CONTAINS:
//* DESCRIPTION:     .
//* NOTES:           .
//*****************************************************************************
//*                   INTEL CORPORATION PROPRIETARY INFORMATION
//*     This software is supplied under the terms of a license agreement or
//*     nondisclosure agreement with Intel Corporation and may not be copied
//*     or disclosed except in accordance with the terms of that agreement.
//*           Copyright (c) 1995-2000 Intel Corporation.  All Rights Reserved.
//*****************************************************************************

#ifndef D_DebugPrint_HeaderFile
#define D_DebugPrint_HeaderFile

#include "CompDiag.h"

#ifdef D_CompilerDiagnostics
   #pragma D_CompDiagMsg("Include")
#endif

#define DEBUGPRINT 0	// Set to 1 to do DebugPrints in free version

/////////////////////////////////////////////////////////////////////////////

#if DBG || DEBUGPRINT

   #define DODEBUGPRINT 1

#else

   #define DODEBUGPRINT 0

#endif

#if DODEBUGPRINT

   void DebugPrintInit(char*);
   void DebugPrintClose();
   void DebugPrintMsg(char*);

#else

   #define DebugPrintInit(x)
   #define DebugPrintClose()
   #define DebugPrintMsg(x)

#endif

void DebugPrintLimit(int max, const char *format, ... );
void DebugPrint(const char *format, ... );

/////////////////////////////////////////////////////////////////////////////

#endif

